; SketchyLISP Extension Library
; Copyright (C) 2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; remp

; ---conformance---
; R5.91RS

; ---purpose---
; Remove members from lists. Create a new list containing the
; members of a given list that do not match a given predicate.

; ---args---
; P - predicate
; A - list

; ---keywords---
; REMP function, remove, property, predicate

; ---see-also---
; remove, remq, remv, memp, assp

; ---example---
; (remp symbol? '(a b c (x . y) d e f)) => ((x . y))

(define remp #t)

; (require "nullp.scm") ; null?
(require "filter.scm")

; ---model---
; (define (remp p a)
;   (cond ((null? a) '())
;     ((p (car a)) (cdr a))
;     (else (cons (car a) (remp x (cdr a))))))

; ---code---
(define (remp p a)
  (filter (lambda (x)
            (not (p x)))
          a))
