; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; tail?

; ---conformance---
; SketchyLISP Extension

; ---purpose---
; Check whether an expression is the tail of another one.

; ---args---
; X - potential tail
; Y - expression

; ---keywords---
; TAIL? function, list, pair, tail

; ---see-also---
; head?, last

; ---example---
; (tail? '(d e f) '(a b c d e f)) => #t

; (require "nullp.scm") ; null?
; (require "lib/equalp.scm") ; equal?

; ---code---
(define (tail? x y)
  (cond ((null? y) (null? x))
    ((equal? x y) #t)
    (else (tail? x (cdr y)))))
