; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; =

; ---conformance---
; R5RS

; ---purpose---
; Check whether all numbers in a sequence are equal.

; ---args---
; A - number
; B... - numbers

; ---keywords---
; = function, equivalence, relation, comparison, predicate

; ---see-also---
; <, >, <=, >=, equal?, not

; ---example---
; (= 123 123 123) => #t

(define equal #t)

(require "pred-iter.scm") ; predicate-iterator
(load "equalp.scm") ; equal?
(load "normalize.scm")

; ---code---
(define =
  (predicate-iterator 
    (lambda (a b)
      (equal? (integer->list (normalize a))
              (integer->list (normalize b))))))
