; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; equal?

; ---conformance---
; R5RS

; ---purpose---
; Compare two forms. Return
; .C #t,
; if the forms print equal.

; ---args---
; A - datum
; B - datum

; ---keywords---
; EQUAL? function, equivalence, relation, comparison, predicate

; ---see-also---
; eqv?, member, =

; ---example---
; (equal? '(a b (c d (e)) f) '(a b (c d (e)) f)) => #t

(define equalp #t)

(require "eqvp.scm") ; eqv?
(require "seqp.scm") ; string=?

; ---code---
(define (equal? a b)
  (cond ((string? a)
      (and (string? b) (string=? a b)))
    ((and (pair? a) (pair? b))
      (and (equal? (car a) (car b))
           (equal? (cdr a) (cdr b))))
; This is actually caught by eqv? below
;     ((or (procedure? a) (procedure? b))
;       (bottom))
    (else (eqv? a b))))
