; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; eqv?

; ---conformance---
; R5RS

; ---purpose---
; Compare data. Return
; .C #t,
; if the data are equivalent atoms.
; .B
; .C Eqv?
; is undefined for compound types (pairs, strings, etc).

; ---args---
; A - datum
; B - datum

; ---keywords---
; EQV? function, equivalence, relation, comparison, predicate

; ---see-also---
; equal?, member, =

; ---example---
; (eqv? 123 123) => #t

(define eqvp #t)

(require "equal.scm") ; =
; (require "ceqp.scm") ; char=?

; ---code---
(define (eqv? a b)
  (cond ((number? a)
      (and (number? b) (= a b)))
    ((char? a)
      (and (char? b) (char=? a b)))
    (else (eq? a b))))
