; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; integer

; ---conformance---
; SketchyLISP Core

; ---purpose---
; Convert a number to an integer.

; ---args---
; A - number

; ---keywords---
; INTEGER function, numbers, digit, integer, conversion

; ---see-also---
; digits, natural

; ---example---
; (integer 567) => +567

(define integer #t)

(require "digits.scm")

; ---code---
(define (integer a)
  (letrec
    ((_integer
       (lambda (a)
         (cond ((eq? (car a) '+) a)
           ((eq? (car a) '-) a)
           (else (cons '+ a))))))
    (list->integer
      (_integer (integer->list a)) #t)))
