; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; list-tail

; ---conformance---
; R5RS

; ---purpose---
; Extract the tail of a list beginning at a given offset.
; The first element is at position 0.

; ---args---
; X - list
; N - position of tail to extract

; ---keywords---
; LIST-TAIL function, list, tail, n'th member, position

; ---see-also---
; caar, append, list-ref

; ---example---
; (list-tail '(a b c d e f) 3) => (d e f)

(define list-tail #t)

; (require "nullp.scm") ; null?
(require "list.scm")
(require "zerop.scm") ; zero?

; ---code---
(define (list-tail x n)
  (cond ((zero? n) x)
    ((null? x) (bottom (list 'list-tail x n)))
    (else (list-tail (cdr x) (n- n 1)))))
