; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; max

; ---conformance---
; R5RS

; ---purpose---
; Find the maximum of a sequence of numbers.

; ---args---
; A - number
; B... - numbers

; ---keywords---
; MAX function, maximum, comparison, arithmetics

; ---see-also---
; digits, min, >

; ---example---
; (max -25 5 25 0 -5) => 25

(define max #t)

(require "fold-left.scm")
(require "if.scm")
(require "greater.scm") ; >

; ---code---
(define (max a . b)
  (fold-left (lambda (a b)
               (if (> a b) a b))
             a b))
