; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; member

; ---conformance---
; R5RS

; ---purpose---
; Return the sublist starting at the first member of a list that
; is equal to a given datum. If no such member exists, return
; .C #f.

; ---args---
; X - datum to find
; A - list

; ---keywords---
; MEMBER function, member of, sets, set theory

; ---see-also---
; memq, memv, assoc

; ---example---
; (member '(c d) '(a b (c d) e f)) => ((c d) e f)

(define member #t)

; (require "nullp.scm") ; null?
(require "equalp.scm") ; equal?

; ---code---
(define (member x a)
  (cond ((null? a) #f)
    ((equal? (car a) x) a)
    (else (member x (cdr a)))))
