; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; memq

; ---conformance---
; R5RS

; ---purpose---
; Return the sublist starting at the first member of a list that
; is identical to a given symbol. If no such member exists, return
; .C #f.

; ---args---
; X - symbol to find
; A - list

; ---keywords---
; MEMQ function, member of, sets, set theory

; ---see-also---
; memv, member, assq

; ---example---
; (memq 'c '(a b c d e f)) => (c d e f)

(define memq #t)

; (require "nullp.scm") ; null?

; ---code---
(define (memq x a)
  (cond ((null? a) #f)
    ((eq? (car a) x) a)
    (else (memq x (cdr a)))))
