; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; memv

; ---conformance---
; R5RS

; ---purpose---
; Return the sublist starting at the first member of a list that
; is equivalent to a given atom. If no such member exists, return
; .C #f.

; ---args---
; X - atom to find
; A - list

; ---keywords---
; MEMV function, member of, sets, set theory

; ---see-also---
; memq, member, assv

; ---example---
; (memv '4 '(1 2 3 4 5 6)) => (4 5 6)

(define memv #t)

(require "eqvp.scm") ; eqv?
; (require "nullp.scm") ; null?

; ---code---
(define (memv x a)
  (cond ((null? a) #f)
    ((eqv? (car a) x) a)
    (else (memv x (cdr a)))))
