; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; min

; ---conformance---
; R5RS

; ---purpose---
; Find the minimum of a sequence of numbers.

; ---args---
; A - number
; B... - numbers

; ---keywords---
; MIN function, minimum, comparison, arithmetics

; ---see-also---
; digits, max, <

; ---example---
; (min 25 5 -25 0 -5) => -25

(define min #t)

(require "fold-left.scm")
(require "if.scm")
(require "less.scm") ; <

; ---code---
(define (min a . b)
  (fold-left (lambda (a b)
               (if (< a b) a b))
             a b))
