; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; natural

; ---conformance---
; SketchyLISP Core

; ---purpose---
; Convert an integer or natural number to a natural number.
; Only non-negative integers can be converted to natural.

; ---args---
; A - number

; ---keywords---
; NATURAL function, numeric, numbers, digit, natural

; ---see-also---
; digits, integer, natural?

; ---example---
; (natural +123) => 123

(define natural #t)

(require "digits.scm")
(require "list.scm")
(require "integer.scm")

; ---code---
(define (natural x)
  (letrec
    ((_natural
       (lambda (list-x)
         (cond ((eq? (car list-x) '+) (cdr list-x))
           ((eq? (car list-x) '-)
             (bottom (list 'natural x)))
           (else list-x)))))
    (list->integer (_natural (integer->list x)) #t)))
