; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; negate

; ---conformance---
; SketchyLISP Core

; ---purpose---
; Compute the negative value of a number.

; ---args---
; X - number

; ---keywords---
; NEGATE function, negative value, arithmetics

; ---see-also---
; digits, -, negative?

; ---example---
; (negate 125) => -125

(define negate #t)

(require "digits.scm")
(require "zerop.scm") ; zero?

; ---code---
(define (negate x)
  (letrec
    ((_negate
       (lambda (x)
         (cond ((eq? (car x) '-) (cdr x))
           ((eq? (car x) '+) (cons '- (cdr x)))
           (else (cons '- x))))))
    (cond ((zero? x) x)
      (else (list->integer
              (_negate (integer->list x)) #t)))))
