; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; positive?

; ---conformance---
; R5RS

; ---purpose---
; Check whether a number is positive.

; ---args---
; X - number

; ---keywords---
; POSITIVE? function, positive value, sign, predicate, numbers

; ---see-also---
; digits, negative?, zero?, abs

; ---example---
; (positive? 567) => #t

(define positivep #t)

(require "digits.scm")
(require "zerop.scm") ; zero?
(require "negativep.scm") ; negative?

; ---code---
(define (positive? x)
  (eq? (or (negative? x)
           (zero? x))
       #f))
