; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; pred

; ---conformance---
; SketchyLISP Core

; ---purpose---
; Find the predecessor of a decimal digit.
; .B
; .C (pred 0d) => ().

; ---args---
; X - symbol representing a digit

; ---keywords---
; PRED function, predecessor, numbers, digits

; ---see-also---
; digits, succ

; ---example---
; (pred 5d) => 4d

(require "digits.scm") ; 0d 1d 2d 3d 4d 5d 6d 7d 8d 9d

; ---code---
(define (pred x)
  (cond ((eq? x 0d) '())
        ((eq? x 1d) 0d)
        ((eq? x 2d) 1d)
        ((eq? x 3d) 2d)
        ((eq? x 4d) 3d)
        ((eq? x 5d) 4d)
        ((eq? x 6d) 5d)
        ((eq? x 7d) 6d)
        ((eq? x 8d) 7d)
        ((eq? x 9d) 8d)
        (else (bottom 'digit 'expected))))
