; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; reverse

; ---conformance---
; R5RS

; ---purpose---
; Reverse a list.

; ---args---
; A - list

; ---keywords---
; REVERSE function, lists, reverse, ordering

; ---see-also---
; append, length, map, equal?, list?

; ---example---
; (reverse '(a b c d e f)) => (f e d c b a)

(define reverse #t)

; (require "nullp.scm") ; null?
; (require "list.scm")
; (require "append.scm")

; ---model---
; (define (reverse a)
;   (cond ((null? a) a)
;     (else (append (reverse (cdr a))
;                   (list (car a))))))

; ---code---
(define (reverse a)
  (letrec
    ((_reverse
       (lambda (a b)
         (cond ((null? a) b)
           (else (_reverse (cdr a)
                   (cons (car a) b)))))))
    (_reverse a '())))
