; SketchyLISP Example Program
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; hyper

; ---language---
; R5RS Scheme

; ---purpose---
; Implement the hyperN operator.
; Compute
; .V a hyperN b.
; .V A, b,
; and
; .V n
; must all be natural numbers.

; ---args---
; N - integer (order)
; A - integer (base)
; B - integer (hyper-exponent)

; ---keywords---
; HYPER function, hyper, hyper4, hyper5, base, exponent, power
; power tower

; ---example---
; (hyper 4 3 3) => 7625597484987

; (require "lib/digits.scm")
; (require "lib/equal.scm") ; =
; (require "lib/times.scm") ; *
; (require "lib/plus.scm") ; +
; (require "lib/minus.scm") ; -
; (require "lib/expt.scm")
; (require "lib/greater.scm") ; >

; ---code---
(define (hyper n a b)
  (cond ((= n 0) (+ b 1))
        ((= n 1) (+ a b))
        ((= b 1) a)
        ((= n 2) (* a b))
        ((= n 3) (expt a b))
        ((= n 4) (expt a (hyper n a (- b 1))))
        ((> n 4) (hyper (- n 1) a (hyper n a (- b 1))))))

; (define (hyper4 a b) (hyper 4 a b))
; (define (hyper5 a b) (hyper 5 a b))
; ...
