; SketchyLISP Example Program
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; vqueens

; ---language---
; R5RS Scheme

; ---purpose---
; Pretty-print a solution of the N-queens problem.

; ---args---
; BOARD-SIZE - size of the board.
; SOLUTION - solution produces by QUEENS.

; ---keywords---
; VQUEENS function, queens, eight queens, N queens, N-queens, example

; ---example---
; (require "src/queens.scm")
; (vqueens 4 (queens 4)) => #t
; ; output:
; ; . . & .
; ; & . . .
; ; . . . &
; ; . & . .

; (require "lib/nullp.scm") ; null?
; (require "lib/zerop.scm") ; zero?
; (require "lib/newline.scm")
; (require "lib/minus.scm") ; -
; (require "lib/remainder.scm")

; ---code---
(define (vqueens board-size solution)
  (letrec
    ((print-dots
       (lambda (n)
         (cond ((zero? n) '())
           (else (begin (display " .")
                        (print-dots (- n 1)))))))
     (print-row
       (lambda (n)
         (begin (print-dots n)
                (display " &")
                (print-dots (- board-size n 1))
                (newline))))
     (print-board
       (lambda (b)
         (or (null? b)
             (begin (print-row
                      (remainder (car b) board-size))
                    (print-board (cdr b)))))))
    (print-board solution)))
